using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Diagnostics;
using System.Windows.Forms;

using WindowsOSLog;
using Common;
using Onyeyiri;
using DesktopWindows;

namespace NovelTechnique
{
    public class QuickStacking
    {
        private HotKeyManager m_keyup,m_keydown;

        public IntPtr ForegroundWindow
        {
            get
            {
                return User32.GetForegroundWindow();
            }
        }

        public int NumberWindows
        {
            get
            {
                return Desktop.DesktopWindows.Values.Count;
            }
        }

        public void  QuickStackingKeyUp()
        {
            m_keyup = new HotKeyManager();
            m_keyup.Register(Keys.Up, HotKeyModifier.Control, 300, new HotKeyEventHandler(QuickStackingKeyUp));
        }

        public void QuickStackingKeyDown()
        {
            m_keydown = new HotKeyManager();
            m_keydown.Register(Keys.Down, HotKeyModifier.Control, 400, new HotKeyEventHandler(QuickStackingKeyDown));
        }

        private void ArrangeStrategy()
        {

        }

        private void QuickStackingKeyUp(int id)
        {
            Desktop m_windows = Desktop.DesktopWindows;
            Windows m_window = m_windows.ForegroundWindow;

            if (m_window.ZOrder < NumberWindows)
            {
                foreach (Windows window in m_windows.Values)
                {
                    if (window.ZOrder == m_window.ZOrder + 1)
                    {
                        User32.SwitchToThisWindow(window.Handle, true);
                    }
                }
            }
        }

        private void QuickStackingKeyDown(int id)
        {

        }
    }
}
